#!/bin/ash
#
# Function: BlockDomain, Run_dnsmasq_manually
# Checking: dig facebook.com @127.0.0.1
# Block: Mon~Fri, 09:00~11:59 14:00~18:59
#

# 01 02 .. 23
_DisableTime="09 10 11 14 15 16 17 18"

# Mon Tue Wed Thu Fri Sat Sun
_DisableDay="Mon Tue Wed Thu Fri"

# Domain
_BlockList="facebook.com youtube.com"

########################################### Code

flagfile="/tmp/BlockDomain.txt"
dnsmasq_config="/etc/dnsmasq.conf"

_Day=`date +"%a"`
_Time=`date +"%H"`

BlockDomain() {
	for d in $_BlockList
	do
		echo "Block $d"
		echo "address=/$d/127.0.0.1"  >> $dnsmasq_config
	done
}

Run_dnsmasq_manually() {
	killall dnsmasq
	sleep 2
	dnsmasq --log-async
	pidof dnsmasq > $flagfile
}

Run_normal_dnsmasq() {
	# no repeat to run
	if [ -e $flagfile ]; then
		echo "reset dnsmasq => allow access all website"
        rm -f $dnsmasq_config
		rm -f $flagfile
        # Asus; It will gen normal dnsmasq config
		service restart_dnsmasq
	else
		echo "Nothing to do ..."
	fi
}

######################################## Main

# Check Day Block
for d in $_DisableDay
do
	# Check Time Block
	for t in $_DisableTime
	do
		if [ $_Time -eq $t ] && [ $_Day = $d ]; then
            echo "Day: $_Day, Time: $_Time"
			if [ -e $flagfile ]; then
				echo "lock file exist => no need run Block"
				touch $flagfile
				exit
			fi
			BlockDomain
			Run_dnsmasq_manually
			# no repeat to run
			touch $flagfile
			exit
		fi
	done
done

# The flow will exit before
Run_normal_dnsmasq

